#
# spec file for package k3kcli
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           k3kcli
Version:        0.3.3
Release:        1.1
Summary:        Kubernetes in Kubernetes
License:        Apache-2.0
URL:            https://github.com/rancher/k3k
Source:         %{name}-%{version}.tar.gz
Source1:        vendor.tar.gz
BuildRequires:  go >= 1.23

%description
A Kubernetes in Kubernetes tool, k3k provides a way to run multiple embedded
isolated k3s clusters on your kubernetes cluster.

%prep
%autosetup -p 1 -a 1

%build
go build \
   -mod=vendor \
   -buildmode=pie \
   -ldflags="-X github.com/rancher/k3k/pkg/buildinfo.Version=v%{version}" \
   -o bin/%{name} ./cli

%install
# Install the binary.
install -D -m 0755 bin/%{name} %{buildroot}/%{_bindir}/%{name}

%check
bin/%{name} --version

%files
%doc README.md
%license LICENSE
%{_bindir}/%{name}

%changelog
* Mon Jun 30 2025 Johannes Kastl <opensuse_buildservice@ojkastl.de>
- Update to version chart-0.3.3-r6:
  * bump charts to 0.3.3-r6 (#401)
  * Add pods/attach permission to k3k-kubelet (#400)
  * Add scheduled Conformance tests for shared mode (#396)
  * bump chart (#395)
  * add named controller (#394)
  * bump charts to 0.3.3-r4 (#393)
  * Generate kubeconfig secret (#392)
  * Bump Charts to `0.3.3-r3` (#391)
  * [CLI] add storage-request-size flag (#372)
  * Fix Network Policy reconciliation (#388)
  * fix-howto usage of serverEnvs and agentEnvs (#385)
  * Fix for `k3kcli policy delete` (#386)
  * kubelet controllers cleanup (#376)
  * Ephemeral containers fix (#371)
  * fix for empty namespace (#375)
  * [DOC] add how-to create virtual clusters (#373)
  * charts-0.3.3-r1 (#370)
  * [DOC] add how to choose mode (#369)
  * add workload exposition howto doc (#366)
  * Added `k3kcli cluster list` and `k3kcli policy list` commands
    (#368)
  * Update `allowedModeTypes` field to `allowedMode` (#367)
  * `VirtualClusterPolicy` documentation (#364)
  * Change `VirtualClusterPolicy` scope to Cluster (#358)
  * move howtos in docs folder (#362)
  * add air-gap support (#359)
  * update version in readme (#357)
  * Fix DNS options and allow custom dnsConfig (#354)
  * remove `--devel` reference (#353)
  * Rename `ClusterSet` to `VirtualClusterPolicy` (#349)
  * Fix annotation update (#335)
  * Fix HA init server scaling (#333)
  * fix build-crds, bump Go to 1.24.2, bump golangci-lint (#344)
  * Services updates (`LoadBalancerConfig` and `NodePortConfig`)
    (#329)
  * Add extra env for servers/agents (#324)
  * Display error if agents flag is provided in shared mode (#330)
  * Update Chart.yaml (#332)
* Fri Apr 18 2025 Johannes Kastl <opensuse_buildservice@ojkastl.de>
- Update to version 0.3.2:
  * fix: Correcting incorrect procedures in advanced-usage.md
  * Update and fix to `k3kcli` for new ClusterSet integration
    (#321)
  * Add `clusterset` commands (#319)
  * Fix delete cli (#281)
  * fix typo (#300)
* Fri Mar 21 2025 opensuse_buildservice@ojkastl.de
- Update to version 0.3.1:
  - Update CRDs documentation by @enrichman in #279
  - Update quickstart pre-requisite and add cli docs by @jp-gouin
    in #273
  - Fix bug with Kubeconfig value resolution by @jp-gouin in #288
  - Fix kubeconfig load from multiple configuration files by
    @enrichman in #301
  - Add documentation to install k3k on k3d by @rossella in #299
* Mon Feb 17 2025 opensuse_buildservice@ojkastl.de
- Update to version 0.3.0:
  CLI-related changes
  * Small cli refactor (`cluster name` as arg, default kubeconfig
    path) (#230)
* Wed Aug  7 2024 Johannes Kastl <opensuse_buildservice@ojkastl.de>
- new package k3kcli: a Kubernetes in Kubernetes tool, k3k provides
  a way to run multiple embedded isolated k3s clusters on your
  kubernetes cluster
